#include<conio>     // gotoxy
#include<dos>       // dos_findfile
#include<string>    // strlen
#include<sys\timeb> // struct timeb
#include<stdio>     // file handling
#include<iostream>  // cin & cout
#include<stdlib>    // atof
using namespace std;
#pragma hdrstop
#include"que.h"     // class que

class coord /* ================================================== CLASS COORD */
   {
   public:
      int x;
      int y;
      int schritt;
      coord(int a, int b, int c)
         {x=a;y=b;schritt=c;}
      coord()
         {}
      void operator = (coord a)
         {x=a.x; y=a.y; schritt=a.schritt;}
   };
que<coord> QUE;
coord ziel;

long delaytime = 50; /* ----------------------------------------------- delay */
void delay(long x)
   {
   struct timeb a,e;
   ftime(&a);
   do {
      ftime(&e);
      } while((e.time*1000+e.millitm) - (a.time*1000+a.millitm) < x);
   }

int **labyrinth, maxx = 25, maxy = 22; /* =================== !!! LABSCAN !!! */
char* mapbak = "maps\\stdmap.txt";
char* mapfile = new(char[256]);

void labscan()
   {
   while(!QUE.empty())
      {
      coord akt = QUE.front();
      QUE.deq();
      if(akt.x < 0 || akt.x > maxx)
         continue;
      if(akt.y < 0 || akt.y > maxy)
         continue;
      if(labyrinth[akt.x][akt.y] != 0)
         continue;
      int x = akt.x, y = akt.y, schritt = akt.schritt;
      coord next;
      next.x = x-1; next.y = y; next.schritt = schritt+1; QUE.enq(next);
      next.x = x+1; next.y = y; next.schritt = schritt+1; QUE.enq(next);
      next.x = x; next.y = y-1; next.schritt = schritt+1; QUE.enq(next);
      next.x = x; next.y = y+1; next.schritt = schritt+1; QUE.enq(next);

      labyrinth[x][y] = schritt;
      gotoxy(x*3+2, y+2);
      cout.width(2);
      cout << schritt;
      delay(delaytime);
      }
   }

void display();
void goback()
   {
   coord next=ziel;
   next.schritt=65536;
   if(labyrinth[next.x-1][next.y] < next.schritt && labyrinth[next.x-1][next.y] > 0)
      next.schritt=labyrinth[next.x-1][next.y]+1;
   if(labyrinth[next.x+1][next.y] < next.schritt && labyrinth[next.x+1][next.y] > 0)
      next.schritt=labyrinth[next.x+1][next.y]+1;
   if(labyrinth[next.x][next.y-1] < next.schritt && labyrinth[next.x][next.y-1] > 0)
      next.schritt=labyrinth[next.x][next.y-1]+1;
   if(labyrinth[next.x][next.y+1] < next.schritt && labyrinth[next.x][next.y+1] > 0)
      next.schritt=labyrinth[next.x][next.y+1]+1;

   for(;;)
      {
      labyrinth[next.x][next.y]=-3;
      if(next.x > 0)
         if(labyrinth[next.x-1][next.y]==next.schritt-1)
            {--next.x; --next.schritt;
            continue;}
      if(next.x < maxx)
         if(labyrinth[next.x+1][next.y]==next.schritt-1)
            {++next.x; --next.schritt;
            continue;}
      if(next.y > 0)
         if(labyrinth[next.x][next.y-1]==next.schritt-1)
            {--next.y; --next.schritt;
            continue;}
      if(next.y < maxy)
         if(labyrinth[next.x][next.y+1]==next.schritt-1)
            {++next.y; --next.schritt;
            continue;}
      break;
      }
   labyrinth[ziel.x][ziel.y]=-2;
   display();
   }

void display() /* =================================================== DISPLAY */
   {
   for(int i = 0; i < strlen(mapbak); i++)
      mapfile[i]=mapbak[i];
   mapfile[strlen(mapbak)]='\0';

   clrscr();
   _setcursortype(_NOCURSOR);
   textcolor(0);
   textbackground(7);
   gotoxy(1,1);
   cprintf(" Labyrinth Scanner v2    2002 by Viktor Engelmann    http://www.AlgorithMan.de ");
   textbackground(0); textcolor(15);
   cprintf(" ");
   for(int i = 0; i <= maxy; i++)
      {
      for(int j = 0; j <= maxx; j++)
         {
         switch(labyrinth[j][i])
            {
            case -1 : cout << "";
                      break;
            case -2 : cprintf(" X ");
                      break;
            case -3 : cprintf(" o ");
                      break;
            default : cprintf("   ");
            	       break;
            }
         }
      cout << "\n ";
      }
   gotoxy((84-strlen(mapfile))/2,25);
   cout << mapfile;
   }

#pragma argsused
void main(int argc, char** args) /* ==================================== main */
   {
   int mousex = 0, mousey = 0;
   _setcursortype(_NOCURSOR);
   labyrinth = new(int*[maxx+1]);
   for(int i = 0; i <= maxx; i++)
      {
      labyrinth[i] = new(int[maxy+1]);
      for(int j = 0; j <= maxy; j++)
      	labyrinth[i][j] = -1;
      }
   /* ----------------------------------------------------- argument handling */
   for(int i = 1; i < argc; i+=2)
      {
      if((args[i][0] == '-') && (args[i][1] == 'm') && (args[i][2] == '\0'))
         mapfile = args[i+1];
      if((args[i][0] == '-') && (args[i][1] == 'd') && (args[i][2] == '\0'))
      	delaytime = atol(args[i+1]);
      }
   /* ---------------------------------------------------- Exception Handling */
   struct find_t findfile;
   while(_dos_findfirst(mapfile, _A_NORMAL, &findfile))
      {
      cout << "please specify a valid mapfile > ";
      cin >> mapfile;
      }
   /* --------------------------------------------------------- file handling */
   FILE* labin = fopen(mapfile, "r");
   char c; int x = 0, y = 0;
   for(;;)
      {
      c = fgetc(labin);
      if(feof(labin))
         goto eoff;
      switch(c)
         {
         case ' ' : labyrinth[x][y] = 0;
                    break;
         case 'M' : mousex = x;
                    mousey = y;
                    labyrinth[x][y] = 0;
                    break;
         case 'X' : labyrinth[x][y] = -2;
                    ziel.x=x;
                    ziel.y=y;
                    break;
         case '\n': x = -1;
                    if(++y > maxy)
                       goto eoff;
                    break;
         default  : labyrinth[x][y] = -1;
         }
      if(++x > maxx)
         {
         x = 0;
         if(++y > maxy)
            goto eoff;
         for(;;)
            {
            c = fgetc(labin);
            if(feof(labin))
               goto eoff;
            if(c == '\n')
               break;
            }
         }
      }
   eoff:
   fclose(labin);
   /* ----------------------------------------------------------- run program */
   display();
   coord first(mousex,mousey,1);
   QUE.enq(first);
   labscan();
   goback();
   getch();
   }
// #############################################################################
